// (unary) boolean functions

gmexport double ds_bin_boolean_not(double dest_id, double id) {
	unsigned long xx,yy,zz;
	ds_bin *dest,*bin;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin=search_bin((unsigned long) id))==NULL) return -1;
	if(!(dest->x==bin->x && dest->y==bin->y && dest->z==bin->z)) {
		return 0;
	}
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				bin_set(dest,xx,yy,zz, !( bin_get(bin,xx,yy,zz) ) );
			}
		}
	}
	return 1;
}

// (unary) bitwise functions

gmexport double ds_bin_bitwise_not(double dest_id, double id) {
	unsigned long i;
	ds_bin *dest,*bin;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin=search_bin((unsigned long) id))==NULL) return -1;
	if(!(dest->bits==bin->bits && dest->x==bin->x && dest->y==bin->y && dest->z==bin->z)) {
		return 0;
	}
	for(i=0;i<dest->count;++i) {
		dest->data[i] = ~( bin->data[i] );
	}
	return 1;
}

gmexport double ds_bin_bitwise_lshift(double dest_id, double id, double bits) {
	unsigned long xx,yy,zz;
	unsigned char shiftbits;
	ds_bin *dest,*bin;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin=search_bin((unsigned long) id))==NULL) return -1;
	if(!(dest->x==bin->x && dest->y==bin->y && dest->z==bin->z)) {
		return 0;
	}
	shiftbits = (unsigned char) bits;
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				bin_set(dest,xx,yy,zz, bin_get(bin,xx,yy,zz) << shiftbits );
			}
		}
	}
	return 1;
}

gmexport double ds_bin_bitwise_rshift(double dest_id, double id, double bits) {
	unsigned long xx,yy,zz;
	unsigned char shiftbits;
	ds_bin *dest,*bin;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin=search_bin((unsigned long) id))==NULL) return -1;
	if(!(dest->x==bin->x && dest->y==bin->y && dest->z==bin->z)) {
		return 0;
	}
	shiftbits = (unsigned char) bits;
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				bin_set(dest,xx,yy,zz, bin_get(bin,xx,yy,zz) >> shiftbits );
			}
		}
	}
	return 1;
}

