// copy functions

gmexport double ds_bin_copy_direct(double dest_id, double src_id) {
	ds_bin *dest,*src;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((src=search_bin((unsigned long) src_id))==NULL) return -1;
	if(!(dest->bits==src->bits && dest->x==src->x && dest->y==src->y && dest->z==src->z)) {
		return 0;
	}
	if(dest!=src) { // I am not sure if memcpy will work if the pointers are the same
		memcpy(dest->data,src->data,dest->size);
	}
	return 1;
}

gmexport double ds_bin_copy(double dest_id, double src_id) {
	unsigned long xx,yy,zz;
	ds_bin *dest,*src;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((src=search_bin((unsigned long) src_id))==NULL) return -1;
	if(!(dest->x==src->x && dest->y==src->y && dest->z==src->z)) {
		return 0;
	}
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				bin_set(dest,xx,yy,zz,bin_get(src,xx,yy,zz));
			}
		}
	}
	return 1;
}

gmexport double ds_bin_copy_part(double dest_id, double src_id, double dest_x, double dest_y, double dest_z, double src_x, double src_y, double src_z, double size_x, double size_y, double size_z) {
	ds_bin *dest,*src;
	unsigned long xx,yy,zz,dx,dy,dz,sx,sy,sz,x,y,z;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((src=search_bin((unsigned long) src_id))==NULL) return -1;
	dx = (unsigned long) dest_x;
	dy = (unsigned long) dest_y;
	dz = (unsigned long) dest_z;
	sx = (unsigned long) src_x;
	sy = (unsigned long) src_y;
	sz = (unsigned long) src_z;
	x = (unsigned long) size_x;
	y = (unsigned long) size_y;
	z = (unsigned long) size_z;
	if(!(dx+x<=dest->x && dy+y<=dest->y && dz+z<=dest->z && sx+x<=src->x && sy+y<=src->y && sz+z<=src->z)) {
		return 0;
	}
	for(zz=0;zz<z;++zz) {
		for(yy=0;yy<y;++yy) {
			for(xx=0;xx<x;++xx) {
				bin_set(dest,dx+xx,dy+yy,dz+zz,bin_get(src,sx+xx,sy+yy,sz+zz));
			}
		}
	}
	return 1;
}

